#include "Arduino.h"

//Datenformat, das verstanden wird:
//    LINKS RECHTS
//   #+4000+4000$

class Datentransfer
{
    private:
        int  puffer[12]= {'#','+','0','0','0','0','+','0','0','0','0','$'};
        int  index  = 0; 
        int LINKS = 0;
        int RECHTS = 0;   
    public:
        void start()
        {
             Serial.begin(9600);          
        }
        
        bool analysierePuffer()
        {
            if(puffer[index]=='$' && puffer[(index+1)%12]=='#' &&

             (puffer[(index+2)%12]=='+' || puffer[(index+2)%12]=='-') && 
             (puffer[(index+7)%12]=='+' || puffer[(index+7)%12]=='-') && 

             (puffer[(index+3)%12]>='0' && puffer[(index+3)%12]<='9') && 
             (puffer[(index+4)%12]>='0' && puffer[(index+4)%12]<='9') && 
             (puffer[(index+5)%12]>='0' && puffer[(index+5)%12]<='9') && 
             (puffer[(index+6)%12]>='0' && puffer[(index+6)%12]<='9') && 
 
             (puffer[(index+8)%12]>='0' && puffer[(index+8)%12]<='9') && 
             (puffer[(index+9)%12]>='0' && puffer[(index+9)%12]<='9') && 
             (puffer[(index+10)%12]>='0' && puffer[(index+10)%12]<='9')&& 
             (puffer[(index+11)%12]>='0' && puffer[(index+11)%12]<='9')
 
            )
          {
              LINKS  = 0;
              LINKS += puffer[(index+3)%12] - '0';          
              LINKS *= 10;
              LINKS += puffer[(index+4)%12] - '0';          
              LINKS *= 10;
              LINKS += puffer[(index+5)%12] - '0';          
              LINKS *= 10;
              LINKS += puffer[(index+6)%12] - '0';          

              if(puffer[(index+2)%12]=='-')
                  LINKS = -LINKS;

              RECHTS  = 0;
              RECHTS += puffer[(index+8)%12] - '0';          
              RECHTS *= 10;
              RECHTS += puffer[(index+9)%12] - '0';          
              RECHTS *= 10;
              RECHTS += puffer[(index+10)%12] - '0';          
              RECHTS *= 10;
              RECHTS += puffer[(index+11)%12] - '0';          

              if(puffer[(index+7)%12]=='-')
                  RECHTS = -RECHTS;

              // Zeit seit letzten korrekten seriellen Signalen "zurücksetzen"     
              //previousMillisSerial=millis();
         
              puffer[0] = ' ';
              puffer[1] = ' ';
              puffer[2] = ' ';
              puffer[3] = ' ';
              puffer[4] = ' ';
              puffer[5] = ' ';
              puffer[6] = ' ';
              puffer[7] = ' ';
              puffer[8] = ' ';
              puffer[9] = ' ';
              puffer[10] = ' ';
              puffer[11] = ' ';
         
              return true;
          }
          else
          {
              return false;
          }
          
        }
  
        int getLINKS()
        {
            return LINKS;
        }        
        int getRECHTS()
        {
            return RECHTS;
        }        
        
        bool aktualisierePuffer()
        {
            if( Serial.available() > 0 ) 
            {
                puffer[index] = Serial.read();
                index++;
                index%=12;
 
                return true;
            }
            else
            {
                return false;
            }
          
        }  
};
