#include "Antrieb.h"
#include "Datentransfer.h"
#include "Totmann.h"

Antrieb antrieb;
Datentransfer datentransfer;
Totmann totmann(1000);


void setup() 
{
    totmann.start();
    datentransfer.start();
    antrieb.start();    
}

void loop() 
{
  
    totmann.auffrischenButton();
  
    if(datentransfer.analysierePuffer()==true)  //nur wenn NEUES drin ist true!!!!
    {
         totmann.auffrischenSerial();
    }
    
    if(totmann.serialOK()==false || totmann.buttonOK()==false)
    {
        antrieb.setzeLinks(0); 
        antrieb.setzeRechts(0);         
    }
    else
    {
        antrieb.setzeLinks(datentransfer.getLINKS()); // PWM Signale ändern  
        antrieb.setzeRechts(datentransfer.getRECHTS()); // PWM Signale ändern  
    }
    
    
    datentransfer.aktualisierePuffer();
}
